%define		PYVER		2.6
%define		__python	python%{PYVER}
%define		PVER		%(echo %{PYVER} | awk -F. '{print$1$2}')
%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}
%define with_ksmarttray 0

Distribution:	CCux
Packager:	Christian Metzen <metzench@ccux-linux.de>

Summary:	Next generation package handling tool
Name:		smart
Version:	1.3.1
Release:	2
BuildArch:	i686
Group:		System/Configuration/Packaging
License:	GNU/GPL
Source0:	smart-%{version}.tar.bz2
#Source1:	locale_de_LC_MESSAGES_smart-de.po
BuildRoot:	%{_tmppath}/%{name}-%{version}-root
Provides:	smart-python%{PVER}
BuildArch:	i686
# Sources:
Source200:	distro.py
Source201:	ccux-repo.channel
Source202:	smart.desktop
Source203:	smart-ksmarttray.desktop
Source204:	smart.console
Source205:	smart.pam
Source206:	smart-install.desktop
Source207:	smart-rpm-install.desktop
Source208:	smart-newer.py
Source209:	smart-1.3-qt-look-icons.tar.bz2
# Patches:
Patch4:         smart-ksmarttray.patch
Patch8:         smart-interactive-newer.patch
Patch9:         smart-no-strict-aliasing.patch
# speedup downloads but keep sane CPU usage
# we previously eliminated the sleep completely to gain maximum
# download speed - which caused high CPU load
# set the sleep time value to a more appropriate value
Patch11:	smart-download-speedup.patch
# fix smart query
#https://bugs.launchpad.net/smart/+bug/525940
Patch12:	smart-query-refactor.diff	
# style up smart
Patch200:	smart-1.3-qt-look.patch
Requires:	python%{PVER}
Requires:	python%{PVER}-pycurl
Requires:	python%{PVER}-elementtree
Requires:	python%{PVER}-pyxml
Requires:	rpm-python%{PVER}
BuildRequires:	python%{PVER}-devel

%if %{with_ksmarttray}
#Dependencies for ksmarttray:
BuildRequires: 	kdelibs3-devel
BuildRequires: 	qt3-devel
BuildRequires: 	make
BuildRequires: 	popt
BuildRequires: 	rpm-devel >= 4.4.2.2
BuildRequires: 	automake
BuildRequires: 	autoconf
%endif

%description
Smart Package Manager is a next generation package handling tool.

%if %{with_ksmarttray}
%package -n	ksmarttray
Summary: 	KDE System Tray for the Smart Package Manager
Group: 		System/Configuration/Packaging
Requires:	%{name} = %{version}-%{release}

%description -n ksmarttray
KDE System Tray for the Smart Package Manager
%endif

%package	addons
Summary:	Additional Bindings and Tools for the Smart Package Manager
Group:		System/Configuration/Packaging
Requires:	%{name} = %{version}-%{release}
Requires:	kdebase

%description	addons
Additional bindings and tools for the Smart package manager.

Currently this package only contains KDE bindings for .channel files.

%package	gui
Summary:	Contains the graphical frontend to smart
Group:		System/Configuration/Packaging
Requires:	%{name} = %{version}-%{release}
Requires:	usermode-gtk
Requires:	python%{PVER}-pygtk python%{PVER}-pyqt3
Requires:	python%{PVER}-pycairo
Requires:	python%{PVER}-pygobject

%description	gui
This package contains the GTK and Qt3 graphical frontend for smart. It allows you to install and update packages in a nice graphical way.

%prep
%setup -q
%patch4
%patch8
%patch9
# speedup downloads but keep sane CPU usage
#%patch11 -p1

#%patch200 -p1

FIX=$(find -type f -name "*" -exec grep -I -l -e "^#!/usr/bin/python" -e "^#!/usr/bin/env python" "{}" \; )
for i in $FIX; do
    sed -i "s,^#!/usr/bin/python,#!/usr/bin/python%{PYVER}," $i
    sed -i "s,^#!/usr/bin/env python,#!/usr/bin/env python%{PYVER}," $i
done

%build
export CFLAGS="$RPM_OPT_FLAGS"
export CXXFLAGS="$RPM_OPT_FLAGS"

#install -m 644 %{SOURCE1} locale/de/LC_MESSAGES/smart.po

%{__python} setup.py build

%if %{with_ksmarttray}
#ksmarttray
pushd contrib/ksmarttray
make -f admin/Makefile.common
./configure --prefix=%_prefix --disable-final
make %{?_smp_mflags}
popd
%endif

#smart-update
pushd contrib/smart-update
make %{?_smp_mflags}
popd

%install
%{__python} ./setup.py install --prefix=%{_prefix} --root="$RPM_BUILD_ROOT"
%__install "%{SOURCE208}" "$RPM_BUILD_ROOT%_libdir/python%{PYVER}/site-packages/smart/commands/newer.py"

# smart-update
install -p -m 0755 contrib/smart-update/smart-update $RPM_BUILD_ROOT%_bindir

%if %{with_ksmarttray}
pushd contrib/ksmarttray
make install DESTDIR=$RPM_BUILD_ROOT
popd
%endif

%{__mkdir_p} $RPM_BUILD_ROOT%{_localstatedir}/lib/smart \
    $RPM_BUILD_ROOT%{_prefix}/lib/smart \
    $RPM_BUILD_ROOT%{_prefix}/lib/smart/plugins \
    $RPM_BUILD_ROOT%{_sysconfdir}/smart/channels

%{__install} -m 0644 %{SOURCE200} $RPM_BUILD_ROOT%{_prefix}/lib/smart/distro.py

%__install -D -m 0755 contrib/servicemenus/kde_add_smart_channel.sh \
	"%{buildroot}%_prefix/bin/kde_add_smart_channel.sh"
%__install -D -m 0644 contrib/servicemenus/add_smart_channel.desktop \
	"%{buildroot}%_prefix/share/apps/konqueror/servicemenus/add_smart_channel.desktop"
%__install -D -m 0644 "%{SOURCE206}" \
	"%{buildroot}%_prefix/share/apps/konqueror/servicemenus/smart-install.desktop"
%__install -D -m 0644 "%{SOURCE207}" \
	"%{buildroot}%_prefix/share/applications/kde/smart-rpm-install.desktop"

%{__install} -m 0644 -D %{SOURCE202} $RPM_BUILD_ROOT/usr/share/applications/%{name}.desktop

%if %{with_ksmarttray}
%{__install} -m 0644 -D %{SOURCE203} $RPM_BUILD_ROOT/usr/share/applications/%{name}-ksmarttray.desktop
%elsif
rm -f $RPM_BUILD_ROOT/usr/share/applications/%{name}-ksmarttray.desktop
%endif

%{__install} -m 0644 -D smart/interfaces/images/smart.png $RPM_BUILD_ROOT/usr/share/pixmaps/smart.png

install -m 644 %{SOURCE201} %{buildroot}/etc/smart/channels

# usermode support
ln -sf consolehelper %{buildroot}%{_bindir}/smart-root

mkdir -p %{buildroot}/etc/security/console.apps
mkdir -p %{buildroot}/etc/pam.d
install -p -m 644 %{SOURCE204} %{buildroot}/etc/security/console.apps/smart-root
install -p -m 644 %{SOURCE205} %{buildroot}/etc/pam.d/smart-root

rm -f $RPM_BUILD_ROOT%{python_sitelib}/*.egg-info

tar xvfj %{SOURCE209} -C %{buildroot}%_libdir/python%{PYVER}/site-packages/smart/interfaces/images

%find_lang %name

%clean
rm -rf %{buildroot}

%files -f smart.lang
%defattr(-,root,root)
%doc HACKING README LICENSE TODO IDEAS
%doc doc/*
%{_mandir}/man8/*
%dir %{_localstatedir}/lib/smart
%dir %{_prefix}/lib/smart
%dir %{_prefix}/lib/smart/plugins
%dir %{_sysconfdir}/smart
%{_bindir}/%{name}
%{_bindir}/%{name}-root
%{_bindir}/%{name}-update
%{_prefix}/lib/smart/distro.py
%_libdir/python%{PYVER}/site-packages/smart
%exclude %_libdir/python%{PYVER}/site-packages/smart/interfaces/gtk
%exclude %_libdir/python%{PYVER}/site-packages/smart/interfaces/qt
#%_libdir/python%{PYVER}/site-packages/smart-%{version}-py%{PYVER}.egg-info

%_sysconfdir/pam.d/smart-root
%_sysconfdir/security/console.apps/smart-root
%config /etc/smart/channels/ccux-repo.channel

%if %{with_ksmarttray}
%files -n ksmarttray
%defattr(-,root,root)
%{_datadir}/applications/smart-ksmarttray.desktop
%_bindir/ksmarttray
%{_datadir}/apps/ksmarttray/eventsrc
%{_datadir}/icons/hicolor/48x48/apps/ksmarttray.png
%endif

%files addons
%defattr(-,root,root)
%attr(0755,root,root) %_prefix/bin/kde_add_smart_channel.sh
%attr(0644,root,root) %_prefix/share/apps/konqueror/servicemenus/add_smart_channel.desktop
%attr(0644,root,root) %_prefix/share/apps/konqueror/servicemenus/smart-install.desktop
%attr(0644,root,root) %_prefix/share/applications/kde/smart-rpm-install.desktop

%files gui
%defattr(-,root,root)
%_applications/smart.desktop
%_pixmaps/smart.png
%_libdir/python%{PYVER}/site-packages/smart/interfaces/gtk
%_libdir/python%{PYVER}/site-packages/smart/interfaces/qt

%changelog
* Mon Jun 07 2010 Karsten Brockmann <arcam@ccux-linux.de> 1.3.1-2
- full released version
* Wed Apr 28 2010 Karsten Brockmann <arcam@ccux-linux.de> 1.3.1-1
- bzr checkout 959
* Wed Mar 24 2010 Karsten Brockmann <arcam@ccux-linux.de> 1.3-13
- fixed smart query
* Wed Feb 17 2010 Christian Metzen <metzench@ccux-linux.de> 1.3-12
- update to final release
- remove our qt fix patches, now all upstream
* Tue Feb 10 2010 Christian Metzen <metzench@ccux-linux.de> 1.3-11
- rewrite patch to really work
* Mon Feb 09 2010 Christian Metzen <metzench@ccux-linux.de> 1.3-10
- additional fix for bug 518729
* Mon Feb 09 2010 Christian Metzen <metzench@ccux-linux.de> 1.3-9
- fix bug 518729
* Mon Feb 09 2010 Christian Metzen <metzench@ccux-linux.de> 1.3-8
- add patch to fix checks in qt interface
* Mon Feb 09 2010 Christian Metzen <metzench@ccux-linux.de> 1.3-7
- add quit button to toolbar
* Mon Feb 09 2010 Christian Metzen <metzench@ccux-linux.de> 1.3-6
- style up qt gui with new icons
* Sun Feb 08 2010 Christian Metzen <metzench@ccux-linux.de> 1.3-5
- another language update
* Sat Feb 06 2010 Christian Metzen <metzench@ccux-linux.de> 1.3-4
- build with update german language file
* Fri Feb 05 2010 Christian Metzen <metzench@ccux-linux.de> 1.3-3
- clean specfile from upstream patches
* Fri Feb 05 2010 Christian Metzen <metzench@ccux-linux.de> 1.3-2
- add python26-pyqt3 dep
- make qt interface the default
* Thu Feb 04 2010 Christian Metzen <metzench@ccux-linux.de> 1.3-1
- Version update to 1.3 bzr branch
* Fri Nov 13 2009 Christian Wasem <wasem@ccux-linux.de> 1.2-7
- added smart-python26 as provides
* Thu Oct 29 2009 Christian Wasem <wasem@ccux-linux.de> 1.2-6
- rebuild against python26-2.6.3-1
* Thu Oct 22 2009 Christian Wasem <wasem@ccux-linux.de> 1.2-5
- rebuild against python25-2.5.4-3
* Fri Jun 26 2009 Karsten Brockmann <arcam@ccux-linux.de> 1.2-4
- fixed high cpu load on smart upgrade
* Thu Jun 25 2009 Stefan Gottwald <gotti@ccux-linux.de> 1.2-3
- fix download timeout after 10 minutes
* Sat Apr 25 2009 Christian Wasem <wasem@ccux-linux.de> 1.2-2
- build with explicit /usr/bin/python2.5
* Sat Mar 22 2009 Christian Metzen <metzench@ccux-linux.de> 1.2-1
- Version update
- removed patches already upstream
* Tue Dec 23 2008 Karsten Brockmann <arcam@ccux-linux.de> 1.1-2
- added workaround/fixes against potential crashes
* Wed Sep 17 2008 Christian Metzen <metzench@ccux-linux.de> 1.1-1
- Version update, temp disable ksmarttray
* Tue Jul 19 2008 Christian Metzen <metzench@ccux-linux.de> 1.0-2
- readded fetcher patch
* Tue Jul 19 2008 Christian Metzen <metzench@ccux-linux.de> 1.0-1
- Version update
* Mon May 19 2008 Christian Metzen <metzench@ccux-linux.de> 0.52-4
- rebuild against pam 1.0.1, needed to get gui working again
- temp disabled ksmarttray
* Tue Mar 25 2008 Christian Wasem <wasem@ccux-linux.de> 0.52-3
- moved .desktop files to gui package
* Sun Nov 11 2007 Simon Schmeisser <wrt@ccux-linux.de> 0.52-2
- seperated gui from the rest, so that smart doesn't have a dependecy on gtk
* Wed Oct 31 2007 Christian Metzen <metzench@ccux-linux.de> 0.52-1
- Version update
* Tue Sep 04 2007 Christian Metzen <metzench@ccux-linux.de> 0.51-2
- added smart fetcher patch to increase download speed
* Tue Sep 04 2007 Christian Metzen <metzench@ccux-linux.de> 0.51-1
- Version update
* Sat Mar 24 2007 Stefan Gottwald <gotti@ccux-linux.de> 0.50-2
- Added usermode-gtk as Require, to allow normal users to use smart
* Thu Jan 18 2007 Christian Metzen <metzench@ccux-linux.de> 0.50-1
- Version update
* Tue Nov 14 2006 Christian Metzen <metzench@ccux-linux.de> 0.49.1-1
- Version update
* Sat Sep 23 2006 Karsten Brockmann <arcam@ccux-linux.de> 0.42-7
- refined requires
* Wed Sep 20 2006 Karsten Brockmann <arcam@ccux-linux.de> 0.42-6
- rebuilt against python 2.5
- svn revision 742
* Tue Sep 05 2006 Christian Metzen <metzench@ccux-linux.de> 0.42-5
- set rpm-force to false, to make smart respect file conflicts
* Sun Aug 27 2006 Christian Metzen <metzench@ccux-linux.de> 0.42-4
- ksmarttray fix
* Wed Aug 16 2006 Christian Metzen <metzench@ccux-linux.de> 0.42-3
- Removed rpm-db config, now in distro.py
* Wed Aug 16 2006 Christian Metzen <metzench@ccux-linux.de> 0.42-2
- Added new patchset, made rpm-sys unremovable.
* Mon Jun 26 2006 Christian Metzen <metzench@ccux-linux.de> 0.42-1
- Version update
* Fri Jun 02 2006 Christian Metzen <metzench@ccux-linux.de> 0.41-8
- some more patching, all latest patches from mailing list
* Fri Jun 02 2006 Christian Metzen <metzench@ccux-linux.de> 0.41-7
- Added patch2, provides mirror tag for channel config
* Fri Jun 02 2006 Christian Metzen <metzench@ccux-linux.de> 0.41-6
- Added patch1, fixes Bug #0000141
* Tue Apr 18 2006 Christian Metzen <metzench@ccux-linux.de> 0.41-5
- update for new repo location
* Thu Feb 23 2006 Christian Metzen <metzench@ccux-linux.de> 0.41-4
- added query patch
* Mon Feb 20 2006 Christian Metzen <metzench@ccux-linux.de> 0.41-3
- Added pycurl require
* Wed Feb 15 2006 Christian Metzen <metzench@ccux-linux.de> 0.41-2
- rebuilt
* Fri Dec 23 2005 Christian Metzen <metzench@ccux-linux.de> 0.41-1
- Version update
* Mon Oct 10 2005 Christian Metzen <metzench@ccux-linux.de> 0.40-2
- Translation update
* Sat Oct 08 2005 Christian Metzen <metzench@ccux-linux.de> 0.40-1
- Version update, translation update
* Sat Sep 24 2005 Christian Metzen <metzench@ccux-linux.de> 0.39-4
- German translation update
* Fri Sep 23 2005 Christian Metzen <metzench@ccux-linux.de> 0.39-3
- Added German Translation
* Tue Sep 13 2005 Christian Metzen <metzench@ccux-linux.de> 0.39-2
- Fixed minor Bug
* Tue Sep 13 2005 Christian Metzen <metzench@ccux-linux.de> 0.39-1
- Version update, moved repo config to extra files
* Thu Sep 09 2005 Christian Metzen <metzench@ccux-linux.de> 0.38-1
- Version update
* Wed Aug 24 2005 Christian Metzen <metzench@ccux-linux.de> 0.37-3
- Cleaned out distro.py, removed smart-update extra package, changed descriptions, added small patch
* Thu Aug 18 2005 Christian Metzen <metzench@ccux-linux.de> 0.37-2
- Temp. removed multiple kernel install possibility
* Mon Aug 15 2005 Christian Metzen <metzench@ccux-linux.de> 0.37-1
- Version update, modified distro.py
* Wed Jul 20 2005 Christian Metzen <metzench@ccux-linux.de> 0.36-2
- Modified distro.py
* Wed Jul 20 2005 Christian Metzen <metzench@ccux-linux.de> 0.36-1
- Initial Release
